local Sol = LibStub("Sol")
KnightCombo = {}
KnightCombo.OnEvent = {}
KnightCombo.Check = {}
KnightCombo.Config = {}
KnightCombo.temp = {}
dofile("Interface/AddOns/KnightCombo/lang/"..GetLanguage():upper().."/main.lua")

KnightCombo.OnLoad = function(this)
	this:RegisterEvent("CASTING_START")
	this:RegisterEvent("CASTING_DELAYED")
	this:RegisterEvent("CASTING_FAILED")
	this:RegisterEvent("CASTING_STOP")
	this:RegisterEvent("UNIT_CLASS_CHANGED")
	this:RegisterEvent("VARIABLES_LOADED")
	KnightCombo_Default = {}
	-- edit by emifa begin
	--KnightCombo_Default["Version"] = "v2.04"					-- Version Number
	KnightCombo_Default["Version"] = "v2.04em"					-- Version Number
	-- edit by emifa end
	KnightCombo_Default["Buff"] = false							-- KnightBuff On/Off
	KnightCombo_Default["LastTarget"] = false					-- Switching back to last target after Buffing
	KnightCombo_Default.LightSealFinish = {}
	KnightCombo_Default.LightSealFinish["Shock"] = true			-- Shock for LightSealFinish
	KnightCombo_Default.LightSealFinish["Punishment"] = true	-- Punishment for LightSealFinish
	KnightCombo_Default.LightSealFinish["Number"] = 3			-- Number of Light Seals for ending
	KnightCombo_Default.HolySealFinish = {}
	KnightCombo_Default.HolySealFinish["Threaten"] = true		-- Threaten for HolySealFinish
	KnightCombo_Default.HolySealFinish["ManaReturn"] = true		-- Mana Return for HolySealFinish
	KnightCombo_Default.HolySealFinish["Percentage"] = 15		-- Percentage for Mana Return
	KnightCombo_Default["WhirlwindShield"] = false				-- Auto Whirlwind Shield On/Off
	KnightCombo_Default["HatredStrike"] = false					-- Auto Hatred Strike On/Off
	KnightCombo_Default["Disarm"] = false						-- Disarmament On/Off
	KnightCombo_Default["AutoResolution"] = false				-- AutoResolution On/Off
	KnightCombo_Default["PercResolution"] = 20					-- AutoResolution Percentage
	KnightCombo_Default["AutoHodH"] = false						-- AutoHallofdeadHeroes On/Off
	KnightCombo_Default["PercHodH"] = 7							-- AutoHallofdeadHeroes Percentage
	-- add by emifa begin
	KnightCombo_Default["Shot"] = false							-- Auto Shot On/Off
	KnightCombo_Default["ShotSlot"] = 22						-- Auto Shot On/Off
	KnightCombo_Default["Vampire Allows"] = false				-- Auto Vampire Allows On/Off
	-- add by emifa end

	SaveVariablesPerCharacter("KnightCombo_Settings")
end

function KnightCombo.OnEvent:OnEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	self[event](self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
end

function KnightCombo.OnEvent:CASTING_START()
	KnightCombo.temp["Action"] = true
end
function KnightCombo.OnEvent:CASTING_STOP()
	KnightCombo.temp["Action"] = nil
end
function KnightCombo.OnEvent:CASTING_FAILED()
	KnightCombo.temp["Action"] = nil
end
function KnightCombo.OnEvent:CASTING_DELAYED()
	KnightCombo.temp["Action"] = nil
end
function KnightCombo.OnEvent:UNIT_CLASS_CHANGED()
	KnightCombo_Settings.MainClass, KnightCombo_Settings.SubClass = UnitClass("player")
end
function KnightCombo.OnEvent:VARIABLES_LOADED()
	if(not KnightCombo_Settings)then
		KnightCombo_Settings = {}
	end
	if((not KnightCombo_Settings["Version"]) or (KnightCombo_Settings["Version"] ~= KnightCombo_Default["Version"]))then
		KnightCombo_Settings["Version"] = KnightCombo_Default["Version"]
		--KC2_Config:Show()
	end
	KC2_Config_Body_LSC_Title:SetText(KnightCombo.lang.Menu["LSC_Title"])
	KC2_Config_T_LSCUse:SetText(KnightCombo.lang.Menu["LSCUse"])
	KC2_Config_T_LightSeals:SetText(KnightCombo.lang.Menu["Light Seals"])
	KC2_Config_T_Shock:SetText(KnightCombo.lang.Menu["Shock"])
	KC2_Config_T_Punishment:SetText(KnightCombo.lang.Menu["Punishment"])
	KC2_Config_Body_HSC_Title:SetText(KnightCombo.lang.Menu["HSC_Title"])
	KC2_Config_T_Threaten:SetText(KnightCombo.lang.Menu["Threaten"])
	KC2_Config_T_ManaReturn:SetText(KnightCombo.lang.Menu["Mana Return"] .. KnightCombo.lang.Menu["at"])
	KC2_Config_Body_Specials_Title:SetText(KnightCombo.lang.Menu["Specials_Title"])
	KC2_Config_T_Disarmament:SetText(KnightCombo.lang.Menu["Disarmament"])
	KC2_Config_T_HatredStrike:SetText(KnightCombo.lang.Menu["Hatred Strike"])
	KC2_Config_T_WhirlwindShiald:SetText(KnightCombo.lang.Menu["Whirlwind Shield"])
	KC2_Config_Body_Buffs_Title:SetText(KnightCombo.lang.Menu["Buffs_Title"])
	KC2_Config_T_AutoResolution:SetText(KnightCombo.lang.Menu["AutoResolution"] .. KnightCombo.lang.Menu["at"])
	KC2_Config_T_AutoHodH:SetText(KnightCombo.lang.Menu["AutoHodH"] .. KnightCombo.lang.Menu["at"])
	KC2_Config_T_AutoBuff:SetText(KnightCombo.lang.Menu["AutoBuff"])
	-- del by emifa begin
	--KC2_Config_Body_Tankmode:SetText(KnightCombo.lang.Menu["Tankmode"])
	-- del by emifa end
	KC2_Config_Body_Reset:SetText(KnightCombo.lang.Menu["Reset"])
	KC2_Config_Body_Save:SetText(KnightCombo.lang.Menu["Save"])
	KC2_Config_Version:SetText(KnightCombo_Settings["Version"])
	-- add by emifa begin
	KC2_Config_T_Shot:SetText(KnightCombo.lang.Menu["Shot"] .. KnightCombo.lang.Menu["at"])
	KC2_Config_T_VampireAllows:SetText(KnightCombo.lang.Menu["Vampire Allows"])
	-- add by emifa end
	Sol._help.AddSettings(KnightCombo_Settings,KnightCombo_Default)
	Sol._help.RemoveSettings(KnightCombo_Settings,KnightCombo_Default)
	KnightCombo_Settings.MainClass, KnightCombo_Settings.SubClass = UnitClass("player")
	KnightCombo.temp.target = ""
	if AddonManager then
		local addon = {
			-- edit by emifa begin
			--name = "KnightCombo",
			name = "KnightCombo Emifa Edition",
			-- edit by emifa end
			description = "Knight Combo is a combination macro that can be used for Knights to make chain skill attacks with a press of a macro button.", -- There is also an auto buffer that will use your buff when your buff wears off.
--			icon = nil,
			category = "Other",
			configFrame = KC2_Config,
			slashCommands = SLASH_KnightCombo2,
--			miniButton = nil,
--			onClickScript = KnightCombo.Config.toggle,
			-- add by emifa begin
			miniButton = KC2_AddonManagerMiniButton,
			onClickScript = KnightCombo.Config.toggle,
			-- add by emifa end
			version = KnightCombo_Default["Version"],
			-- edit by emifa begin
			author = "Davion with Emifa",
			-- edit by emifa end
--			disableScript = KnightCombo.disableBuff,
--			enableScript = KnightCombo.enableBuff,
		}
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon)
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author)
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("Knight Combo addon is loaded.",0.1,0.8,0.1)
	end
end

KnightCombo.enableBuff = function()
	KnightCombo_Settings["Buff"] = true
	KnightCombo.Config.Load()
end

KnightCombo.disableBuff = function()
	KnightCombo_Settings["Buff"] = false
	KnightCombo.Config.Load()
end

KnightCombo.DebugMsg = function(Msg,red,green,blue)
	if (KnightCombo_Settings["Debug"])then
		if(UnitName("target"))then
			KnightCombo.temp.target = UnitName("target")
		else
			KnightCombo.temp.target = ""
		end
		if(not KnightCombo.temp["Debug"])then
			KnightCombo.temp["Debug"] = ""
		end
		KnightCombo.temp["Debug"] = KnightCombo.temp["Debug"] .. "\n" .. Msg
		KC2_Debug_Text:SetText()
	end
end

KnightCombo.Reset = function()
	KnightCombo_Settings = KnightCombo_Default
	KnightCombo_Settings.MainClass, KnightCombo_Settings.SubClass = UnitClass("player")
	KnightCombo.Config.Load()
end

-- CHECKER ------------------------------------------------------------------------------------------------

KnightCombo.Check.Class = function()
    if(KnightCombo_Settings.MainClass == KnightCombo.lang["Knight"])then
		return 1
	elseif(KnightCombo_Settings.SubClass == KnightCombo.lang["Knight"])then
		return 2
	else
		KnightCombo.DebugMsg("This is for Knight mainclass or subclass only.",0.1,0.8,0.1)
		return false
	end
end

---- Buffchekcer all credits to TBDjp ----------------------------------------
local KnightCombo_mount = {
	"charger",       -- some mounts in shop & bag
	"mount",         -- most mounts in shop item
	"skill_kni59%-1", -- horse
	"skill_thi3%-2",  -- Rogue skill hide
	"skill_thi54%-1"  -- Rogue skill vanish
}

KnightCombo.Check.Mount = function()
	local buffID = 0
	local i = 1
	local buffName, buffIcon, buffCount = UnitBuff("player",i)
	while(buffName)do
		buffName, buffIcon, buffCount = UnitBuff("player",i)
		if(buffIcon)then
			buffIcon=tostring(buffIcon)
			for key, value in pairs(KnightCombo_mount)do
				if(string.find (buffIcon, KnightCombo_mount[key]) ~= nil)then
					buffID = i
				end
			end
		end
		i = i + 1
	end
	return buffID > 0
end

KnightCombo.Check.Shield = function()
	if(not GetInventoryItemCount("player",16))then
		KnightCombo.DebugMsg(UnitName("player") .. " hat kein Item im SecondaryHandSlot",0,1,0)
		return false
	else
		KnightCombo.DebugMsg(UnitName("player") .. " hat ein Item im SecondaryHandSlot",1,0,0)
		return true
	end
end

KnightCombo.Check.Cooldown = function(SkillName)
	local tabNum, skillNum = Sol.data.skills.GetSkillbookIndeces(SkillName)
	local cooldown, remaining = GetSkillCooldown(tabNum, skillNum)
	return remaining
end

KnightCombo.Check.Buff = function(target,buffName)
	local buffed = Sol.data.skills.UnitHasBuff(target, buffName)
	if(buffed)then
		if((buffName ~= (KnightCombo.lang.Skills["Holy Seal"])) and (buffName ~= (KnightCombo.lang.Skills["Enhanced Armor"])) and (buffName ~= (KnightCombo.lang.DeBuffs["Significantly Enhanced Armor"])))then
			KnightCombo.DebugMsg(KnightCombo.temp.target .. " hat " .. buffName,0,1,0)
		end
	elseif((buffName ~= (KnightCombo.lang.Skills["Holy Seal"])) and (buffName ~= (KnightCombo.lang.Skills["Enhanced Armor"])) and (buffName ~= (KnightCombo.lang.DeBuffs["Significantly Enhanced Armor"])))then
		KnightCombo.DebugMsg(KnightCombo.temp.target .. " hat " .. buffName .. " nicht",1,0,0)
	end
	return buffed
end

KnightCombo.Check.Debuff = function(target,debuffName)
	local debuffed = Sol.data.skills.UnitHasDeBuff(target, debuffName)
	if(debuffed)then
		KnightCombo.DebugMsg(KnightCombo.temp.target .. " hat " .. debuffName,0,1,0)
	else
		KnightCombo.DebugMsg(KnightCombo.temp.target .. " hat " .. debuffName .. " nicht",1,0,0)
	end
	return debuffed
end

-- TankMode ------------------------------------------------------------------------------------------------

KnightCombo.TankMode = function()
	if(KnightCombo.Check.Class() ~= 1)then
		KnightCombo_Settings["WhirlwindShield"] = false
		KnightCombo_Settings["HatredStrike"] = false
		KnightCombo_Settings.HolySealFinish["Threaten"] = false
		KnightCombo_Settings.HolySealFinish["ManaReturn"] = false
		KnightCombo_Settings.LightSealFinish["Shock"] = false
	elseif((not KnightCombo_Settings["WhirlwindShield"]) or (not KnightCombo_Settings["HatredStrike"]))then
		KnightCombo_Settings["WhirlwindShield"] = true
		KnightCombo_Settings["HatredStrike"] = true
		KnightCombo_Settings.HolySealFinish["Threaten"] = true
		KnightCombo_Settings.HolySealFinish["ManaReturn"] = false
		SendWarningMsg("Knight Combo: Tank Mode |cff4CFF00ON|r.")
	else
		KnightCombo_Settings["WhirlwindShield"] = false
		KnightCombo_Settings["HatredStrike"] = false
		KnightCombo_Settings.HolySealFinish["Threaten"] = false
		KnightCombo_Settings.HolySealFinish["ManaReturn"] = true
		SendWarningMsg("Knight Combo: Tank Mode |cffff0000OFF|r.")
	end
	KnightCombo.Config.Load()
end

-- ATTACKS ------------------------------------------------------------------------------------------------

KnightCombo.CastSpell = function(skillName)
	local tabNum, spellNum = Sol.data.skills.GetSkillbookIndeces(skillName)
	local Name, temp1, skillIcon, temp2, skillLVL , temp3, tpNextLvl, temp4, learned = GetSkillDetail(tabNum, spellNum)
	if((KnightCombo.Check.Cooldown(skillName) == 0) and (learned) and ((not KnightCombo.temp["InCombo"]) or (not KnightCombo.temp["Done"])))then
		KnightCombo.DebugMsg("Caste " .. skillName,0,0,1)
		CastSpellByName(skillName)
		if(KnightCombo.temp["InCombo"])then
			KnightCombo.temp["Done"] = true
		end
	elseif(not learned)then
		KnightCombo.DebugMsg("Das Level f・ " .. skillName .. " ist noch nicht erreicht. Bitte ・erpr・e deine Einstellungen",0.1,0.8,0.1)
	end
end

KnightCombo.HatredStrike = function()
	if((KnightCombo.Check.Class() == 1) and (KnightCombo_Settings["HatredStrike"]))then
		KnightCombo.CastSpell(KnightCombo.lang.Skills["Hatred Strike"])
	end
end

KnightCombo.Whirlwindshield = function()
	if((KnightCombo.Check.Class() == 1) and (KnightCombo_Settings["WhirlwindShield"]) and (KnightCombo.Check.Shield()))then
		KnightCombo.CastSpell(KnightCombo.lang.Skills["Whirlwind Shield"])
	end
end

KnightCombo.Disarmament = function()
	if((not KnightCombo.Check.Class() == false) and (KnightCombo_Settings["Disarm"]) and (KnightCombo.temp["InCombo"]) and (not KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Disarmament IV"])))then
		KnightCombo.CastSpell(KnightCombo.lang.Skills["Disarmament"])
	elseif(not KnightCombo.temp["InCombo"])then
		KnightCombo.CastSpell(KnightCombo.lang.Skills["Disarmament"])
	end
end


KnightCombo.LightSealCombo = function()
	KnightCombo.DeathBuff()
	KnightCombo.Buff()
	KnightCombo.DebugMsg("----------------------LightSealCombo BEG-------------------.",0.1,0.8,0.1)
	KnightCombo.temp["InCombo"] = true
	KnightCombo.HatredStrike()
	KnightCombo.Whirlwindshield()
	KnightCombo.Disarmament()
	if(not KnightCombo.Check.Class() == false)then
		if(KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"]]) or KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"] + 1]) or KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"] + 2]))then
			if(KnightCombo_Settings.LightSealFinish["Shock"])then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Shock"])
			end
			if(KnightCombo_Settings.LightSealFinish["Punishment"])then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Punishment"])
			end
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Holy Strike"])
		else
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Holy Strike"])
		end
	end
	KnightCombo.temp["Done"] = nil
	KnightCombo.temp["InCombo"] = nil
	KnightCombo.DebugMsg("----------------------LightSealCombo END-------------------.",0.1,0.8,0.1)
end

KnightCombo.HolySealCombo = function()
	KnightCombo.DebugMsg("----------------------HolySealCombo BEG--------------------.",0.1,0.8,0.1)
	if(KnightCombo.Check.Class() == 1)then
		if(KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Holy Seal III"]))then
			KnightCombo.temp["InCombo"] = true
			if(KnightCombo_Settings.HolySealFinish["Threaten"])then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Threaten"])
			end
			if(KnightCombo_Settings.HolySealFinish["ManaReturn"] and (UnitMana("player")/UnitMaxMana("player") <= KnightCombo_Settings.HolySealFinish["Percentage"]/100))then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Mana Return"])
			end
			KnightCombo.LightSealCombo()
			KnightCombo.temp["Done"] = nil
			KnightCombo.temp["InCombo"] = nil
		else
			KnightCombo.LightSealCombo()
		end
	KnightCombo.DebugMsg("----------------------HolySealCombo END--------------------.",0.1,0.8,0.1)
	elseif(KnightCombo.Check.Class() == 2)then
		KnightCombo.LightSealCombo()
	end
end

KnightCombo.Stun = function()
	KnightCombo.DeathBuff()
	KnightCombo.Buff()
	KnightCombo.DebugMsg("----------------------Stun BEG-----------------------------.",0.1,0.8,0.1)
	if((not KnightCombo.Check.Class() == false) and (not KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Charge Effect"])) and (not KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Restrained"])))then
		KnightCombo.temp["InCombo"] = true
		if(KnightCombo.Check.Class() == 1)then
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Charge"])
		end
		if(KnightCombo.Check.Shield())then
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Shield of Atonement"])
		end
		KnightCombo.temp["Done"] = nil
		KnightCombo.temp["InCombo"] = nil
	end
	KnightCombo.DebugMsg("----------------------Stun END-----------------------------.",0.1,0.8,0.1)
end

-- BUFFS ------------------------------------------------------------------------------------------------

KnightCombo.Buff = function()
	KnightCombo.DebugMsg("----------------------Buff BEG-----------------------------.",0.1,0.8,0.1)
	if(KnightCombo_Settings["Buff"])then
		KnightCombo.temp["InCombo"] = true
		KnightCombo.temp["Done"] = nil
		if((not KnightCombo.Check.Class() == false) and (not KnightCombo.Check.Mount()) and (not KnightCombo.temp["Action"]))then
			if(KnightCombo_Settings["LastTarget"])then
				FocusUnit(12,"target")
			end
			if((KnightCombo.Check.Class() == 1) and (not KnightCombo.Check.Buff("player",KnightCombo.lang.Skills["Holy Seal"])))then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Holy Seal"])
			end
			if((not KnightCombo.Check.Buff("player",KnightCombo.lang.Skills["Enhanced Armor"])) and (not KnightCombo.Check.Buff("player",KnightCombo.lang.DeBuffs["Significantly Enhanced Armor"])))then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Enhanced Armor"])
			end
			if(KnightCombo_Settings["LastTarget"])then
				TargetUnit("focus12")
				FocusUnit(12,"")
			end
		end
		KnightCombo.temp["InCombo"] = nil
	end
	KnightCombo.DebugMsg("----------------------Buff END-----------------------------.",0.1,0.8,0.1)
end

KnightCombo.DeathBuff = function()
	KnightCombo.DebugMsg("----------------------DBuff BEG----------------------------.",0.1,0.8,0.1)
	if((KnightCombo.Check.Class() == 1) and (not KnightCombo.Check.Mount()) and (not KnightCombo.temp["Action"]))then
		KnightCombo.temp["InCombo"] = true
		KnightCombo.temp["Done"] = nil
		if((KnightCombo_Settings["AutoResolution"]) and (UnitHealth("player")/UnitMaxHealth("player") <= KnightCombo_Settings["PercResolution"]/100))then
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Resolution"])
		end
		if((KnightCombo_Settings["AutoHodH"]) and (UnitHealth("player")/UnitMaxHealth("player") <= KnightCombo_Settings["PercHodH"]/100))then
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Hall of Dead Heroes"])
		end
		KnightCombo.temp["InCombo"] = nil
	end
	KnightCombo.DebugMsg("----------------------DBuff END----------------------------.",0.1,0.8,0.1)
end

-- Menu and other stuff ------------------------------------------------------------------------------------------------
SLASH_KnightCombo1 = "/knightcombo"
SLASH_KnightCombo2 = "/kc"
SlashCmdList["KnightCombo"] = function(editBox, msg)
	msg = string.lower(msg)
	if(msg == "reset")then
		KnightCombo.Reset()
	elseif(msg == "lightsealcombo")then
		KnightCombo.LightSealCombo()
	elseif(msg == "holysealcombo")then
		KnightCombo.HolySealCombo()
	elseif(msg == "stuncombo")then
		KnightCombo.Stun()
	elseif(msg == "buff")then
		KnightCombo.Buff()
	elseif(msg == "deathbuff")then
		KnightCombo.DeathBuff()
	elseif(msg == "tankmode")then
		KnightCombo.TankMode()
	elseif(msg == "debug")then
		KC2_Debug_Text:SetText(KnightCombo.temp["Debug"])
		KC2_Debug_Text:HighlightText()
		KC2_Debug_Text:SetFocus()
		if(not KC2_Debug:IsVisible())then
			KC2_Debug:Show()
		end
-- emifa add begin
	elseif(msg == "vampiresword")then
		KnightCombo.VampireSword()
	elseif(msg == "succubussword")then
		KnightCombo.SuccubusSword()
	elseif(msg == "drinkpotion")then
		KnightCombo.DrinkPotion()
	elseif(msg == "lonlywolffang")then
		KnightCombo.LonlyWolfFang()
-- emifa add end
	else
		KnightCombo.Config.toggle()
	end
end

KnightCombo.Config.Load = function()
	KC2_Config_Shock:SetChecked((KnightCombo_Settings.LightSealFinish["Shock"] and 1) or nil)
	KC2_Config_Punishment:SetChecked((KnightCombo_Settings.LightSealFinish["Punishment"] and 1) or nil)
	KC2_Config_LSCNumber:SetText(KnightCombo_Settings.LightSealFinish["Number"])
	KC2_Config_Threaten:SetChecked((KnightCombo_Settings.HolySealFinish["Threaten"] and 1) or nil)
	KC2_Config_ManaReturn:SetChecked((KnightCombo_Settings.HolySealFinish["ManaReturn"] and 1) or nil)
	KC2_Config_PercTHSC:SetText(KnightCombo_Settings.HolySealFinish["Percentage"])
	KC2_Config_Disarmament:SetChecked((KnightCombo_Settings["Disarm"] and 1) or nil)
	KC2_Config_HatredStrike:SetChecked((KnightCombo_Settings["HatredStrike"] and 1) or nil)
	KC2_Config_WhirlwindShield:SetChecked((KnightCombo_Settings["WhirlwindShield"] and 1) or nil)
	KC2_Config_AutoResolution:SetChecked((KnightCombo_Settings["AutoResolution"] and 1) or nil)
	KC2_Config_PercResolution:SetText(KnightCombo_Settings["PercResolution"])
	KC2_Config_AutoHodH:SetChecked((KnightCombo_Settings["AutoHodH"] and 1) or nil)
	KC2_Config_PercHodH:SetText(KnightCombo_Settings["PercHodH"])
	KC2_Config_AutoBuff:SetChecked((KnightCombo_Settings["Buff"] and 1) or nil)
	-- add by emifa begin
	KC2_Config_Shot:SetChecked((KnightCombo_Settings["Shot"] and 1) or nil)
	KC2_Config_ShotSlot:SetText(KnightCombo_Settings["ShotSlot"])
	KC2_Config_VampireAllows:SetChecked((KnightCombo_Settings["Vampire Allows"] and 1) or nil)
	-- add by emifa end
end

KnightCombo.Config.Close = function()
	KC2_Config:Hide()
end

KnightCombo.Config.Save = function()
	KnightCombo_Settings.LightSealFinish["Shock"] = (KC2_Config_Shock:IsChecked() and true) or false
	KnightCombo_Settings.LightSealFinish["Punishment"] = (KC2_Config_Punishment:IsChecked() and true) or false
	KnightCombo_Settings.LightSealFinish["Number"] = KC2_Config_LSCNumber:GetText()
	KnightCombo_Settings.HolySealFinish["Threaten"] = (KC2_Config_Threaten:IsChecked() and true) or false
	KnightCombo_Settings.HolySealFinish["ManaReturn"] = (KC2_Config_ManaReturn:IsChecked() and true) or false
	KnightCombo_Settings.HolySealFinish["Percentage"] = KC2_Config_PercTHSC:GetText()
	KnightCombo_Settings["Disarm"] = (KC2_Config_Disarmament:IsChecked() and true) or false
	KnightCombo_Settings["HatredStrike"] = (KC2_Config_HatredStrike:IsChecked() and true) or false
	KnightCombo_Settings["WhirlwindShield"] = (KC2_Config_WhirlwindShield:IsChecked() and true) or false
	KnightCombo_Settings["AutoResolution"] = (KC2_Config_AutoResolution:IsChecked() and true) or false
	KnightCombo_Settings["PercResolution"] = KC2_Config_PercResolution:GetText()
	KnightCombo_Settings["AutoHodH"] = (KC2_Config_AutoHodH:IsChecked() and true) or false
	KnightCombo_Settings["PercHodH"] = KC2_Config_PercHodH:GetText()
	KnightCombo_Settings["Buff"] = (KC2_Config_AutoBuff:IsChecked() and true) or false
	-- add by emifa begin
	KnightCombo_Settings["Shot"] = (KC2_Config_Shot:IsChecked() and true) or false
	KnightCombo_Settings["ShotSlot"] = KC2_Config_ShotSlot:GetText()
	KnightCombo_Settings["Vampire Allows"] = (KC2_Config_VampireAllows:IsChecked() and true) or false
	-- add by emifa end
end

KnightCombo.Config.toggle = function()
	if(KC2_Config:IsVisible())then
		KC2_Config:Hide()
	else
		KC2_Config:Show()
	end
end


-- add Emifa
local EMKC_ENEMY_ELITE = 2
local EMKC_SUBGENERAL = 3
local EMKC_SHOT = 1
local EMKC_DIS_TIME = {};
EMKC_DIS_TIME["I"] = 6.0;
EMKC_DIS_TIME["II"] = 6.0;
EMKC_DIS_TIME["III"] = 6.0;
EMKC_DIS_TIME["IV"] = 3.0;

KnightCombo.RefinedDisarmament = function()
	if (not KnightCombo.Check.Class() == false) and (KnightCombo_Settings["Disarm"]) and (KnightCombo.temp["InCombo"]) then
		local i=1;
		local buffName, buffIcon = UnitBuff("player",i);
		local needDis = true;

		while( UnitBuff("player", i) ~= nil ) do
			buffName, buffIcon = UnitBuff("player", i);
			buffLeft = UnitBuffLeftTime("player", i);
			
			if ( buffName == KnightCombo.lang.DeBuffs["Disarmament IV"] ) then
				if ( buffLeft > EMKC_DIS_TIME["IV"] ) then
					needDis = false;
				end
			elseif ( buffName == KnightCombo.lang.DeBuffs["Disarmament III"] ) then
				if ( buffLeft > EMKC_DIS_TIME["III"] ) then
					needDis = false;
				end
			elseif ( buffName == KnightCombo.lang.DeBuffs["Disarmament II"] ) then
				if ( buffLeft > EMKC_DIS_TIME["II"] ) then
					needDis = false;
				end
			elseif ( buffName == KnightCombo.lang.DeBuffs["Disarmament I"] ) then
				if ( buffLeft > EMKC_DIS_TIME["I"] ) then
					needDis = false;
				end
			end
			i=i+1;
		end	
	
		if ( needDis ) then
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Disarmament"]);
		end
	end
end

KnightCombo.SuccubusSword = function()
	KnightCombo.DebugMsg("----------------------SuccubusSword BEG--------------------.",0.1,0.8,0.1)
	if(KnightCombo.Check.Class() == 1)then
		if(KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Holy Seal III"]))then
			KnightCombo.temp["InCombo"] = true
			if ( UnitSex("target") > EMKC_ENEMY_ELITE ) then
				if(KnightCombo_Settings.HolySealFinish["Threaten"])then
					KnightCombo.CastSpell(KnightCombo.lang.Skills["Threaten"])
				end
			end
			if(KnightCombo_Settings.HolySealFinish["ManaReturn"] and (UnitMana("player")/UnitMaxMana("player") <= KnightCombo_Settings.HolySealFinish["Percentage"]/100))then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Mana Return"])
			end
			KnightCombo.VampireSword()
			KnightCombo.temp["Done"] = nil
			KnightCombo.temp["InCombo"] = nil
		else
			KnightCombo.VampireSword()
		end
	elseif(KnightCombo.Check.Class() == 2)then
		KnightCombo.VampireSword()
	end
	KnightCombo.DebugMsg("----------------------SuccubusSword END--------------------.",0.1,0.8,0.1)
end

KnightCombo.VampireSword = function()
	KnightCombo.DeathBuff()
	KnightCombo.Buff()
	KnightCombo.DebugMsg("----------------------VampireSword BEG-------------------.",0.1,0.8,0.1)
	KnightCombo.temp["InCombo"] = true
	
	-- shot
	if ( KnightCombo_Settings["Shot"] ) then
		if ( GetActionUsable( KnightCombo_Settings["ShotSlot"] ) ) then
			UseSkill(EMKC_SUBGENERAL, EMKC_SHOT);
		end
	end
	
	-- Sacred Protection
	--KnightCombo.CastSpell("ホーリーレジスタンス")
	
	-- Vampire Arrows
	if ( KnightCombo_Settings["Vampire Allows"] ) then
		KnightCombo.CastSpell(KnightCombo.lang.Skills["Vampire Allows"])
	end
	
	if ( UnitSex("target") > EMKC_ENEMY_ELITE ) then
		KnightCombo.HatredStrike();
	end

	--KnightCombo.HatredStrike()
	KnightCombo.Whirlwindshield()
	KnightCombo.RefinedDisarmament()
	if(not KnightCombo.Check.Class() == false)then
		if(KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"]]) or KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"] + 1]) or KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Light Seal " .. KnightCombo_Settings.LightSealFinish["Number"] + 2]))then
			if(KnightCombo_Settings.LightSealFinish["Shock"])then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Shock"])
			end
			if(KnightCombo_Settings.LightSealFinish["Punishment"])then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Punishment"])
			end
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Holy Strike"])
		else
			KnightCombo.CastSpell(KnightCombo.lang.Skills["Holy Strike"])
		end
	end
	KnightCombo.temp["Done"] = nil
	KnightCombo.temp["InCombo"] = nil
	KnightCombo.DebugMsg("----------------------VampireSword END-------------------.",0.1,0.8,0.1)
end

KnightCombo.DrinkPotion = function()
	if ( UnitHealth("player") / UnitMaxHealth("player") <= 30 / 100 ) then
		UseItemByName("Lv3フィリウスポーション");
	elseif ( UnitHealth("player") / UnitMaxHealth("player") <= 55 / 100 ) then
		UseItemByName("Lv2フィリウスポーション");
	elseif ( UnitHealth("player") / UnitMaxHealth("player") <= 75 / 100 ) then
		UseItemByName("Lv1フィリウスポーション");
	elseif ( UnitHealth("player") / UnitMaxHealth("player") <= 95 / 100 ) then
		UseItemByName("スピリットハーブ");
	end
end

KnightCombo.LonlyWolfFang = function()
	KnightCombo.DebugMsg("----------------------LonlyWolfFang BEG--------------------.",0.1,0.8,0.1)
	if(KnightCombo.Check.Class() == 1)then
		KnightCombo.DrinkPotion()
		if(KnightCombo.Check.Debuff("target",KnightCombo.lang.DeBuffs["Holy Seal III"]))then
			KnightCombo.temp["InCombo"] = true
			if(KnightCombo_Settings.HolySealFinish["ManaReturn"] and (UnitMana("player")/UnitMaxMana("player") <= KnightCombo_Settings.HolySealFinish["Percentage"]/100))then
				KnightCombo.CastSpell(KnightCombo.lang.Skills["Mana Return"])
			end
			KnightCombo.VampireSword()
			KnightCombo.temp["Done"] = nil
			KnightCombo.temp["InCombo"] = nil
		else
			KnightCombo.VampireSword()
		end
	elseif(KnightCombo.Check.Class() == 2)then
		KnightCombo.VampireSword()
	end
	KnightCombo.DebugMsg("----------------------LonlyWolfFang END--------------------.",0.1,0.8,0.1)
end
